﻿var selNodeElem = document.getElementById('selectedNodeId');
var curModeElem = document.getElementById('currentMode');
var imagesUrl = document.getElementById('imagesUrl').value;

// Gets the current node Id
function GetSelectedNodeId() {
    return selNodeElem.value;
}

// Sets the current node Id
function SetSelectedNodeId(nodeId) {
    selNodeElem.value = nodeId;
}

// Gets the current node Id
function GetCurrentMode() {
    return curModeElem.value;
}

// Sets the current node Id
function SetCurrentMode(mode) {
    curModeElem.value = mode;
}

// ACTIONS

// Processes the node selection
function SelectNode(nodeId) {
    SetSelectedNodeId(nodeId);
    DisplayDocument();
}

// Mode set action - sets the current editing mode
function SetMode(mode) {
    if (!CheckChanges()) {
        return false;
    }

    SetCurrentMode(mode);
    if (mode == 'edit') {
        skm_selectNewItem('menuRight', document.getElementById('menuRight-000'), imagesUrl + 'edit.gif', imagesUrl + 'edit.gif', 'MenuItemRightOver', 'MenuItemRight'); skm_closeSubMenus(document.getElementById('menuRight'));
    }
    else if (mode == 'preview') {
        skm_selectNewItem('menuRight', document.getElementById('menuRight-001'), imagesUrl + 'preview.gif', imagesUrl + 'preview.gif', 'MenuItemRightOver', 'MenuItemRight'); skm_closeSubMenus(document.getElementById('menuRight'));
    }
    else if (mode == 'livesite') {
        skm_selectNewItem('menuRight', document.getElementById('menuRight-002'), imagesUrl + 'live.gif', imagesUrl + 'live.gif', 'MenuItemRightOver', 'MenuItemRight'); skm_closeSubMenus(document.getElementById('menuRight'));
    }
    else if (mode == 'listing') {
        skm_selectNewItem('menuRight', document.getElementById('menuRight-003'), imagesUrl + 'listing.gif', imagesUrl + 'listing.gif', 'MenuItemRightOver', 'MenuItemRight'); skm_closeSubMenus(document.getElementById('menuRight'));
    }
    DisplayDocument();
    return true;
}

// Displays the selected document in the current mode
function DisplayDocument() {
    mode = GetCurrentMode();
    nodeId = GetSelectedNodeId();
    if (mode == 'edit') {
        parent.frames['contentview'].location.href = contentDir + "contenteditframeset.aspx?nodeid=" + nodeId;
    }
    else if (mode == 'preview') {
        parent.frames['contentview'].location.href = contentDir + "documentframeset.aspx?action=preview&nodeid=" + nodeId;
    }
    else if (mode == 'livesite') {
        parent.frames['contentview'].location.href = contentDir + "livesite.aspx?nodeid=" + nodeId;
    }
    else if (mode == 'listing') {
        parent.frames['contentview'].location.href = contentDir + "documentframeset.aspx?action=listing&nodeid=" + nodeId;
    }
}


// Not allowed action
function NotAllowed(baseUrl, action) {
}


// New document action
function NewDocument(parentNodeId, classId) {
    if (parentNodeId != 0) {
        SetMode('edit');
        parent.frames['contentview'].location.href = contentDir + "documentframeset.aspx?action=new&nodeid=" + parentNodeId + "&classid=" + classId;
    }
}


// Particular document delete action
function DeleteDocument(nodeId) {
    if (nodeId > 0) {
        SetSelectedNodeId(nodeId);
        DeleteItem();
    }
}


// Switches to editing mode of particular document
function EditDocument(nodeId) {
    SetMode('edit');
    parent.frames['contentview'].location.href = contentDir + "contenteditframeset.aspx?mode=editform&nodeid=" + nodeId;
}


// New item action
function NewItem() {
    if (!CheckChanges()) {
        return false;
    }

    if (GetSelectedNodeId() != 0) {
        SetMode('edit');
        parent.frames['contentview'].location.href = "documentframeset.aspx?action=new&nodeid=" + GetSelectedNodeId();
    }
}

// Delete item action
function DeleteItem() {
    if (!CheckChanges()) {
        return false;
    }

    if (GetSelectedNodeId() != 0) {
        parent.frames['contentview'].location.href = contentDir + "documentframeset.aspx?action=delete&nodeid=" + GetSelectedNodeId();
    }
}

// Move item action
function MoveItem() {
    if (!CheckChanges()) {
        return false;
    }

    if (GetSelectedNodeId() != 0) {
        // Display node selection dialog in move mode
        modalDialog('../../CMSFormControls/Selectors/SelectNodeDialog/default.aspx?action=move&nodeid=' + GetSelectedNodeId(), 'contentselectnode', 400, 600);
    }
}

// Copy item action
function CopyItem() {
    if (!CheckChanges()) {
        return false;
    }

    if (GetSelectedNodeId() != 0) {
        // Display node selection dialog in copy mode
        modalDialog('../../CMSFormControls/Selectors/SelectNodeDialog/default.aspx?action=copy&nodeid=' + GetSelectedNodeId(), 'contentselectnode', 400, 600);
    }
}

// Move UP item action
function MoveUp() {
    if (!CheckChanges()) {
        return false;
    }

    if (GetSelectedNodeId() != 0) {
        parent.frames['contenttree'].MoveUp(GetSelectedNodeId());
    }
}

// Move DOWN item action
function MoveDown() {
    if (!CheckChanges()) {
        return false;
    }

    if (GetSelectedNodeId() != 0) {
        parent.frames['contenttree'].MoveDown(GetSelectedNodeId());
    }
}

// Performs the copy node action
function CopyNode(nodeId, targetId) {
    if (!CheckChanges()) {
        return false;
    }

    parent.frames['contenttree'].CopyNode(nodeId, targetId);
}

// Performs the move node action
function MoveNode(nodeId, targetId) {
    if (!CheckChanges()) {
        return false;
    }

    parent.frames['contenttree'].MoveNode(nodeId, targetId);
}

// Performs the change language action
function ChangeLanguage(selectElem) {
    if (!CheckChanges()) {
        return false;
    }

    parent.frames['contenttree'].ChangeLanguage(GetSelectedNodeId(), selectElem.value);
}

function CheckChanges() {
    try {
        if (parent.frames['contentview'].CheckChanges) {
            return parent.frames['contentview'].CheckChanges();
        }
    }
    catch (exception) {
    }

    return true;
}