using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.Forums;
using CMS.CMSHelper;
using CMS.LicenseProvider;
using CMS.UIControls;

public partial class CMS_Project_CMSSolution_CMS_ForumSubscription_List : CMSForumsPage
{
    protected int forumId = 0;

    protected override void OnPreInit(EventArgs e)
    {
        base.OnPreInit(e);
        // External call
        if (QueryHelper.GetBoolean("changemaster", false))
        {
            this.MasterPageFile = "~/CMSMasterPages/UI/TabLevel1.master";
        }
    }


    protected void Page_Load(object sender, EventArgs e)
	{
        forumId = QueryHelper.GetInteger("forumid", 0);

        this.subscriptionList.ForumID = forumId;
        this.subscriptionList.OnAction += new CommandEventHandler(subscriptionList_OnAction);

        InitializeMasterPage(forumId);
    }

    
    protected void subscriptionList_OnAction(object sender, CommandEventArgs e)
    {
        switch (e.CommandName.ToLower())
        {
            case "edit":
                UrlHelper.Redirect("ForumSubscription_Edit.aspx?subscriptionId=" + e.CommandArgument);
                break;
        }
    }


    /// <summary>
    /// Initializes Master Page.
    /// </summary>
    protected void InitializeMasterPage(int forumId)
    {
        this.Title = "Forums - Subscriptions List";

        // Set actions
        string[,] actions = new string[1, 8];
        actions[0, 0] = "HyperLink";
        actions[0, 1] = ResHelper.GetString("ForumSubscription_List.NewItemCaption");
        if (forumId > 0)
        {
            actions[0, 3] = ResolveUrl("ForumSubscription_Edit.aspx?forumid=" + forumId.ToString());
        }
        actions[0, 5] = UrlHelper.ImagesDirectory + "/CMSModules/Forums/Tools/Subscriptions/newsubscription.gif";
        this.CurrentMaster.HeaderActions.Actions = actions;
    }
}
